import { system, world } from '@minecraft/server';

function durabilityOnChanged(item, player, isHitEntity = false) {
    let level = item.getComponent("minecraft:enchantable")?.getEnchantment("unbreaking")?.level;

    function durability() {
        let durability = item.getComponent("minecraft:durability");

        const t = Math.floor(Math.random() * 100);

        if (t < durability.getDamageChance()) {
            if (!isHitEntity) durability.damage += 1;
            if (durability.damage >= durability.maxDurability) {
                player.playSound("random.break");
                if (!isHitEntity) player.getComponent('equippable').setEquipment('Mainhand', undefined)
            } else {
                if (!isHitEntity) player.getComponent('equippable').setEquipment('Mainhand', item)
            }
        } else {
            if (!isHitEntity) return;
            durability.damage -= 1;
            if (!isHitEntity) player.getComponent('equippable').setEquipment('Mainhand', item);
        }
    }

    const t = Math.floor(Math.random() * 10)
    if (level === 1 && t > 8) return;
    else if (level === 2 && t > 6) return;
    else if (level === 3 && t > 4) return;
    else durability();
}

world.beforeEvents.worldInitialize.subscribe(initEvent => { initEvent.itemComponentRegistry.registerCustomComponent('tlz_mutant_trident:trigger', {
  
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('tlz_blazecharged_sword:trigger', {
  
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('tlz_mutanted_armored_potion:trigger', {
  onConsume: e => {
  e.source.addEffect("minecraft:absorption", 2000, {amplifier: 100});
e.source.addEffect("minecraft:conduit_power", 600, {amplifier: 50});
e.source.addEffect("minecraft:health_boost", 600, {amplifier: 80});
e.source.addEffect("minecraft:instant_damage", 600, {amplifier: 100});
e.source.addEffect("minecraft:night_vision", 600, {amplifier: 25});
e.source.addEffect("minecraft:regeneration", 600, {amplifier: 100});
e.source.addEffect("minecraft:strength", 600, {amplifier: 10});
e.source.removeEffect("minecraft:wither");
e.source.removeEffect("minecraft:poison");
e.source.removeEffect("minecraft:nausea");
e.source.removeEffect("minecraft:fatal_poison");
e.source.removeEffect("minecraft:blindness");
e.source.removeEffect("minecraft:hunger");
e.source.removeEffect("minecraft:weakness");
e.source.removeEffect("minecraft:mining_fatigue");
  
},

  
});

initEvent.itemComponentRegistry.registerCustomComponent('tlz_mutanted_jar_of_blood:trigger', {
  onConsume: e => {
  e.source.addEffect("minecraft:absorption", 1000, {amplifier: 100});
e.source.addEffect("minecraft:conduit_power", 1000, {amplifier: 50});
e.source.addEffect("minecraft:health_boost", 1000, {amplifier: 80});
e.source.addEffect("minecraft:instant_damage", 600, {amplifier: 100});
e.source.addEffect("minecraft:night_vision", 800, {amplifier: 25});
e.source.addEffect("minecraft:regeneration", 1000, {amplifier: 100});
e.source.addEffect("minecraft:strength", 810.0, {amplifier: 10});
e.source.removeEffect("minecraft:wither");
e.source.removeEffect("minecraft:poison");
e.source.removeEffect("minecraft:nausea");
e.source.removeEffect("minecraft:fatal_poison");
e.source.removeEffect("minecraft:blindness");
e.source.removeEffect("minecraft:hunger");
e.source.removeEffect("minecraft:weakness");
e.source.removeEffect("minecraft:mining_fatigue");
  
},

  
});

initEvent.itemComponentRegistry.registerCustomComponent('tlz_mutanted_iron_sword:trigger', {
  
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('tlz_mutanted_wooden_sword:trigger', {
  
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('tlz_mutanted_stone_sword:trigger', {
  
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});
 });
{initEvent.itemComponentRegistry.registerCustomComponent("tlz_mutant_throwable_bone:trigger", {
    onUse: e => {
        const equippable = e.source.getComponent("minecraft:equippable");
        if (!equippable) return;
        const mainhand = equippable.getEquipmentSlot("Mainhand");
        if (!mainhand.hasItem()) return;
        mainhand.amount++;
    },
})
}
{initEvent.itemComponentRegistry.registerCustomComponent("tlz_mutant_enderman_pink_hand:trigger", {
    onUse: e => {
        const equippable = e.source.getComponent("minecraft:equippable");
        if (!equippable) return;
        const mainhand = equippable.getEquipmentSlot("Mainhand");
        if (!mainhand.hasItem()) return;
        mainhand.amount++;
    },
})
}
{initEvent.itemComponentRegistry.registerCustomComponent("tlz_mutant_heavy_core:trigger", {
    onUse: e => {
        const equippable = e.source.getComponent("minecraft:equippable");
        if (!equippable) return;
        const mainhand = equippable.getEquipmentSlot("Mainhand");
        if (!mainhand.hasItem()) return;
        mainhand.amount++;
    },
})
}
